<ion-app>
  <ion-content>
    <ng-container *ngIf="dispatchView else dataAwaitedBlk">
      <mat-expansion-panel>
        <mat-expansion-panel-header>
          <mat-panel-title>
            <mat-icon class="e-mat-icon e-mat-icon--1">date_range</mat-icon>
            <span class="eh-ml-12">{{recallLog.date.seconds * 1000 | date:'E | d-MMM-y':'+0530'}}</span>
            <span *ngIf="recallLogInitial.isNew" class="e-txt e-txt--matred300 eh-txt-12 eh-txt-bold eh-ml-8">
              New!
            </span>
          </mat-panel-title>
    
          <mat-panel-description fxLayoutAlign="end">
            <div *ngIf="hasRecallFormGroupChanged()" class="e-txt e-txt--matred600" fxLayout="row"
              fxLayoutAlign="start center">
              <mat-icon class="e-mat-icon e-mat-icon--3">warning</mat-icon>
              <span class="eh-txt-12 eh-ml-4 eh-txt-bold">Unsaved changes</span>
            </div>
          </mat-panel-description>
        </mat-expansion-panel-header>
    
        <div class="eh-mt-16" fxLayout="row" fxLayoutAlign="end">
          <app-button-icon-title [title]="'Reset'" [buttonStyle]="'e-txt e-txt--matred600'"
            [icon]="'settings_backup_restore'" [disabled]="loading" (onButtonClick)="onReset()"></app-button-icon-title>
    
          <app-button-icon-title class="eh-ml-16 eh-mr-4" [title]="'Save'" [buttonStyle]="'e-txt e-txt--matgreen500'"
            [icon]="'save'" [loading]="loading" (onButtonClick)="onSave()"></app-button-icon-title>
        </div>
    
        <!-- 
         * START | HTML to be reviewed
        -->
        <div class="eh-mt-16">
          <form [formGroup]="recallFormGroup">
            <div fxLayout="row" fxLayoutAlign="start start">
              <div class="e-title e-title--1" fxFlex="grow">
                <mat-icon class="e-mat-icon e-mat-icon--3 eh-mr-8">feedback</mat-icon>
                <span>General</span>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Did you eat any meal out?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="isOutsideMeal"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="isOutsideMeal" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="isOutsideMeal" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  If yes, how many meals?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <input matInput formControlName="outsideMealsCount" type="text">
                  </mat-form-field>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Did you skip any meal?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="isMealSkipped"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="isMealSkipped" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="isMealSkipped" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  If yes, how many meals?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <input matInput formControlName="skippedMealsCount" type="text">
                  </mat-form-field>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Any change in routine?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="isRoutineChanged"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="isRoutineChanged" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="isRoutineChanged" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  If yes, please share details
                </div>
                <div class="e-title e-title--1 eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <textarea matInput formControlName="routineChangeDetails" cdkTextareaAutosize
                      cdkAutosizeMinRows="5"></textarea>
                  </mat-form-field>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Hungry between meals?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="isHungryBetweenMeals"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="isHungryBetweenMeals" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="isHungryBetweenMeals" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Did you consume alcohol?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="isAlcoholConsumed"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="isAlcoholConsumed" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="isAlcoholConsumed" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  If yes, how much?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <input matInput formControlName="alcoholConsumedDetails" type="text">
                  </mat-form-field>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Water intake as recommended?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="isHydrationFollowed"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="isHydrationFollowed" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="isHydrationFollowed" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Average intake per day
                </div>
                <div class="eh-ml-12" style="max-width: 100px;">
                  <mat-form-field class="eh-w-100p">
                    <input matInput formControlName="hydrationIntake" type="text">
                  </mat-form-field>
                </div>
                <div class="eh-ml-4" fxFlex="grow">
                  litre
                </div>
              </div>
            </div>
    
            <div fxLayout="row" fxLayoutAlign="start start">
              <div class="e-title e-title--1 eh-mt-28" fxFlex="grow">
                <mat-icon class="e-mat-icon e-mat-icon--3 eh-mr-8">content_paste</mat-icon>
                <span>Overall Feedback</span>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="e-title e-title--1 eh-ml-12" style="width: 400px;">
                  <mat-form-field class="eh-w-100p">
                    <textarea matInput formControlName="overallFeedback" cdkTextareaAutosize
                      cdkAutosizeMinRows="5"></textarea>
                  </mat-form-field>
                </div>
              </div>
            </div>
    
            <div fxLayout="row" fxLayoutAlign="start start">
              <div class="e-title e-title--1 eh-mt-28" fxFlex="grow">
                <mat-icon class="e-mat-icon e-mat-icon--3 eh-mr-8">feedback</mat-icon>
                <span>Athlete Feedback</span>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Did you have any competition?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="hadCompetition"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="hadCompetition" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="hadCompetition" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  How was your performance?
                </div>
                <div class="e-title e-title--1 eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <textarea matInput formControlName="competitionPerformance" cdkTextareaAutosize
                      cdkAutosizeMinRows="5"></textarea>
                  </mat-form-field>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  How was your recovery?
                </div>
                <div class="e-title e-title--1 eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <textarea matInput formControlName="competitionRecovery" cdkTextareaAutosize
                      cdkAutosizeMinRows="5"></textarea>
                  </mat-form-field>
                </div>
              </div>
            </div>
    
            <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center">
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  Any upcoming competitions?
                </div>
                <div class="eh-ml-12" fxFlex="grow">
                  <mat-radio-group class="e-mat-radio-group" matInput formControlName="upcomingCompetition"
                    aria-label="Select an option">
                    <mat-radio-button class="eh-ml-8" [checked]="upcomingCompetition" [value]="true">
                      Yes
                    </mat-radio-button>
                    <mat-radio-button class="eh-ml-8" [checked]="upcomingCompetition" [value]="false">
                      No
                    </mat-radio-button>
                  </mat-radio-group>
                </div>
              </div>
    
              <div class="eh-mt-8" fxLayout="row" fxLayoutAlign="start center" fxFlex="grow">
                <div class="eh-txt-right" style="min-width: 200px;">
                  If yes, please specify what & when
                </div>
                <div class="e-title e-title--1 eh-ml-12" fxFlex="grow">
                  <mat-form-field class="eh-w-100p">
                    <textarea matInput formControlName="upcomingCompetitionDetails" cdkTextareaAutosize
                      cdkAutosizeMinRows="5"></textarea>
                  </mat-form-field>
                </div>
              </div>
            </div>
          </form>
        </div>
        <!-- 
         * END | HTML to be reviewed
        -->
      </mat-expansion-panel>
    </ng-container>
    
    <ng-template #dataAwaitedBlk>
      <div class="e-spinner">
        <mat-spinner [diameter]="30" [strokeWidth]="3"></mat-spinner>
      </div>
    </ng-template>
  </ion-content>
</ion-app>